﻿clockFmt = "%a %d/%b" -- From http://www.lua.org/pil/22.1.html

local m = Minimap
local font = "FONTS\\FRIZQT__.ttf"
local mailicon = "Interface\\AddOns\\wMmap\\texture\\mail"
local color2 = {r = 0, g = 0, b = 0}
local wMmap = CreateFrame'frame', "|cff44CCFFwMmap|r"

local minimapshape = "round" -- square or round shape of minimap
showDate = true -- Set to false to hide date

m:ClearAllPoints()
m:SetPoint("TOPRIGHT", UIParent, -15, -15)
m:SetScale(1) -- Change to make the Scale of the minimap big or small 0.10 to 0.01 "small" = 1 to 10 big

if minimapshape == "round" then 
function GetMinimapShape() return "ROUND" end
	m:SetMaskTexture("Interface\\AddOns\\wMmap\\texture\\Mask-ROUND")
	
        local r = m:CreateTexture(nil,"round")
	r:SetTexture("Interface\\AddOns\\wMmap\\texture\\round")
	r:SetPoint("TOPLEFT", m, "TOPLEFT", -12, 12)
	r:SetPoint("BOTTOMRIGHT", m, "BOTTOMRIGHT", 12, -12)
	r:SetBlendMode("BLEND")

elseif minimapshape == "square" then 
function GetMinimapShape() return "SQUARE" end
	m:SetMaskTexture("Interface\\AddOns\\wMmap\\texture\\Mask.blp")
	
        local s = m:CreateTexture(nil,"square")
	s:SetTexture("Interface\\AddOns\\wMmap\\texture\\square")
	s:SetPoint("TOPLEFT", m, "TOPLEFT", -12, 12)
	s:SetPoint("BOTTOMRIGHT", m, "BOTTOMRIGHT", 12, -12)
	s:SetBlendMode("BLEND")

		end
----------------------------------
-- Hide stuff
----------------------------------
local stuff = {
    "MiniMapVoiceChatFrame",
    "MiniMapWorldMapButton",
    --"MinimapZoneTextButton",
    "MiniMapMailBorder",
    "MinimapBorderTop",
    "MinimapNorthTag",
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapTracking",
    "MinimapBorder",
    "GameTimeFrame",
    "MiniMapBattlefieldBorder",
    "MiniMapLFGFrameBorder",
}
for i,v in pairs(stuff) do
  getglobal(v).Show = function() end
  getglobal(v):Hide()
end

--==SLASH COMMANDS==--
-- reload the ui
SlashCmdList["RELOADUI"] = function() ReloadUI() end
SLASH_RELOADUI1 = "/rl"

--==AchievementWatchFrame==--
WatchFrame:ClearAllPoints()	
WatchFrame.ClearAllPoints = function() end
WatchFrame:SetPoint("TOPRIGHT", m, "BOTTOMRIGHT", 0, -80)
WatchFrame.SetPoint = function() end
WatchFrame:SetClampedToScreen(true)
WatchFrame:SetHeight(500)

--==Zone text==--
MinimapZoneTextButton:SetPoint("TOP", m, "TOP", 0, 4)
MinimapZoneTextButton:SetFrameLevel(5)
MinimapZoneText:SetFont(font, 10, "OUTLINE")

--==BATTLEGROUND ICON==--
MiniMapBattlefieldFrame:SetFrameLevel(3)
MiniMapBattlefieldBorder:Hide()

--==LFG ICON==--
MiniMapLFGFrameBorder:Hide()

--==BATTLEGROUND ICON TOP==--
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", m, 0, -3)
MiniMapBattlefieldFrame:SetScale(.9)
MiniMapBattlefieldBorder:Hide()

--==Minimap Instance Difficulty TOP RIGHT==--
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", m, 0, 0)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")

--==LFG FRAME BOTTOM RIGHT==--
function UpdateLFG()
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetParent(m)
MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", m, 0, -3)
MiniMapLFGFrame:SetScale(.9)
    LFDSearchStatus:ClearAllPoints()
    LFDSearchStatus:SetPoint("TOPRIGHT", MiniMapLFGFrame, "TOPRIGHT")
end
MiniMapLFGFrameBorder:SetAlpha(0)
DropDownList1:SetClampedToScreen(true)
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)

--==MAIL FRAME BOTTOM==--
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetParent(m)
MiniMapMailFrame:SetPoint('BOTTOM', 0, 18)
MiniMapMailFrame:SetHeight(10)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture(mailicon)

----------------------------------
-- Time
----------------------------------
LoadAddOn('Blizzard_TimeManager')

local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:Show()
clockTime:SetFont(font, 14)
    if(CalendarGetNumPendingInvites() > 0) then
		clockTime:SetTextColor(0, 1, 0)
	else
		clockTime:SetTextColor(1, 1, 1)
    end
TimeManagerClockButton:SetPoint("CENTER", m, "BOTTOM", -2, 2)

if showDate then
	local fdate = CreateFrame("Frame", nil, UIParent)

	fdate.text = fdate:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
	fdate.text:SetPoint("TOP", m, "BOTTOM", -3, -4)

	fdate:SetScript("OnUpdate", function()
		fdate.text:SetText(date(clockFmt))
	end)
end

----------------------------------
-- Zoom
----------------------------------
m:EnableMouseWheel(true)
	m:SetScript("OnMouseWheel", function()
		if arg1 > 0 then Minimap_ZoomIn() else Minimap_ZoomOut() end
	end)

----------------------------------
-- Set Clicks
----------------------------------
m:SetScript('OnMouseUp', function(self, button)
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (m:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)

----------------------------------
-- Move Stuff
----------------------------------

  	m:RegisterForDrag("LeftButton")
	m:SetClampedToScreen(true)
	m:SetMovable(true)
	m:SetScript("OnDragStart", function(self) if IsAltKeyDown() and IsControlKeyDown() then self:StartMoving() end end)
	m:SetScript("OnDragStop", function(self) if IsAltKeyDown() and IsControlKeyDown() then self:StopMovingOrSizing() end end)

m:SetFrameStrata("BACKGROUND")
wMmap:SetScript("OnEvent", event)
wMmap:RegisterEvent("PLAYER_LOGIN") 